package jrr;


import robocode.*;


public class CrazyStrategy extends StrategyAdapter {
    private AdvancedRobot i;
    private boolean movingForward;
    public CrazyStrategy(AdvancedRobot robot) {
        this.i = robot;
    }
    
    public void run() {
        i.setAhead(40000);
        movingForward = true;
        i.setTurnRight(90);
        i.waitFor(new TurnCompleteCondition(i));
        i.setTurnLeft(180);
        i.waitFor(new TurnCompleteCondition(i));
        i.setTurnRight(180);
        i.waitFor(new TurnCompleteCondition(i));
    }
	
    public void onHitWall(HitWallEvent e) {
        reverseDirection();
    }
    
    private void reverseDirection() {
        if (movingForward) {
            i.setBack(40000);
        } else {
            i.setAhead(40000);
        }
        movingForward = !movingForward;
    }
	
    public void onScannedRobot(ScannedRobotEvent e) {
        i.fire(1);
    }
    
    public void onHitRobot(HitRobotEvent e) {
        if (e.isMyFault()) {
            reverseDirection();
        }
    }
}
