package jrr;

import robocode.*;

public class LNE extends AdvancedRobot implements Strategy {
    protected int current = 0;
    protected Strategy[] strategy = new Strategy[] {
                  new TagAlongStrategy(this), 
                  new TrackFireStrategy(this),
    };
    
    public void run() {
        while (true) {
            int currentAtStartOfOuterWhileLoop = current;

            strategy[current].preRun();
            while (current == currentAtStartOfOuterWhileLoop) {
                strategy[current].run();
            }
        }
    }
    
    public void onBulletHit(BulletHitEvent e) {
        strategy[current].onBulletHit(e);
    }

    public void onBulletHitBullet(BulletHitBulletEvent e) {
        strategy[current].onBulletHitBullet(e);
    }
    
    public void onBulletMissed(BulletMissedEvent e) {
        strategy[current].onBulletMissed(e);
    }

    public void onCustomEvent(CustomEvent e) {
        strategy[current].onCustomEvent(e);
    }
    
    public void onDeath(DeathEvent e) {
        strategy[current].onDeath(e);
    }

    public void onHitByBullet(HitByBulletEvent e) {
        strategy[current].onHitByBullet(e);
        changeStrategy();
    }

    public void onHitRobot(HitRobotEvent e) {
        strategy[current].onHitRobot(e);
    }

    public void onHitWall(HitWallEvent e) {
        strategy[current].onHitWall(e);
    }

    public void onRobotDeath(RobotDeathEvent e) {
        strategy[current].onRobotDeath(e);
    }

    public void onScannedRobot(ScannedRobotEvent e) {
        strategy[current].onScannedRobot(e);
    }

    public void onWin(WinEvent e) {
        //strategy[current].onWin(e);
        turnGunRight(36000);
    }

    public void preRun() {}
    
    private void changeStrategy() {
        clearAllEvents();
        current++;
        if (current == strategy.length) {
            current = 0;
        }
    }
}
