package jrr;

import java.util.Random;
import robocode.*;

public class TagAlongStrategy extends StrategyAdapter {
    private AdvancedRobot i;
    private boolean movingForward;
    private TurnCompleteCondition turnComplete;
    private Random random;
    public TagAlongStrategy(AdvancedRobot robot) {
        this.i = robot;
        turnComplete = new TurnCompleteCondition(i);
        random = new Random();
    }
    
    public void run() {
        i.setAhead(7000);
        i.setTurnRight(random.nextInt(360));
        i.waitFor(turnComplete);
        i.setTurnLeft(random.nextInt(360));
        i.waitFor(turnComplete);
        movingForward = true;
    }
	
    public void onHitWall(HitWallEvent e) {
        reverseDirection();
    }
    
    private void reverseDirection() {
        if (movingForward) {
            i.setBack(7000);
        } else {
            i.setAhead(7000);
        }
        movingForward = !movingForward;
    }
	
    public void onScannedRobot(ScannedRobotEvent e) {
        i.fire(1);
        turnAway();
        i.waitFor(turnComplete);
    }
    
    private void turnAway() {
        i.setTurnLeft(30);
    }
}
