package jrr;

import robocode.*;

public class TrackFireStrategy extends StrategyAdapter {
    private AdvancedRobot i;
    public TrackFireStrategy(AdvancedRobot robot) {
        this.i = robot;
/*        i.addCustomEvent(new Condition("lowEnergy") {                            
            public boolean test() {                                             
                return (i.getEnergy() <= 20);
            }
        }); */ 
    }

    public void run() {
        i.turnGunRight(10);
    }
    
    public void onCustomEvent(CustomEvent e) {
        if ("lowEnergy".equals(e.getCondition().getName())) {
            // move away
            i.turnLeft(55);
            i.ahead(200);
        }
    }
    
    public void onScannedRobot(ScannedRobotEvent e) {
        double absoluteBearing = i.getHeading() + e.getBearing();
        double bearingFromGun = normalRelativeAngle(absoluteBearing - i.getGunHeading());

        if (Math.abs(bearingFromGun) <= 3) {
            i.turnGunRight(bearingFromGun);
            if (i.getGunHeat() == 0) {
                i.fire(Math.min(3 - Math.abs(bearingFromGun), i.getEnergy() - .1));
            }
        } else {
            i.turnGunRight(bearingFromGun);
        }
        if (bearingFromGun == 0) {
            i.scan();
        }
    }
    
    public void onWin(WinEvent e) {
        i.turnRight(36000);
    }
	
    private double normalRelativeAngle(double angle) {
        if (angle > -180 && angle <= 180) {
            return angle;
        }
        double fixedAngle = angle;

        while (fixedAngle <= -180) {
            fixedAngle += 360;
        }
        while (fixedAngle > 180) {
            fixedAngle -= 360;
        }
        return fixedAngle;
    }
}				

