package jrr;

import robocode.*;

public class WallStrategy extends StrategyAdapter {
    private Robot i;
    private boolean peek;
    private double moveAmount;
    
    public WallStrategy(Robot robot) {
        this.i = robot;
    }
    
    public void preRun() {
        moveAmount = Math.max(i.getBattleFieldWidth(), i.getBattleFieldHeight());
        peek = false;
        i.turnLeft(i.getHeading() % 90);
        i.ahead(moveAmount);
        peek = true;
        i.turnGunRight(90);
        i.turnRight(90);
    }
    
    public void run() {
        peek = true;
        i.ahead(moveAmount);
        peek = false;
        i.turnRight(90);
    }
    
    public void onHitRobot(HitRobotEvent e) {
        if (e.getBearing() > -90 && e.getBearing() < 90) {
            i.back(100);
        } else {
            i.ahead(100);
        }
    }
    
    public void onScannedRobot(ScannedRobotEvent e) {
        i.fire(2);
        if (peek) {
            i.scan();
        }
    }
}
